;
;
;
;
;
;
;
;
;
;
;
;
;
;
;
;
;
;
;
;  328p
;  16   .
;
;
;
;
;**************************************************************************************************************
;  
;**************************************************************************************************************

.include 	"m328Pdef.inc"		;  ATMega328p


;==============================================================================================================
;   // RAM
;==============================================================================================================
;
;******************************************************************************
;  
;******************************************************************************

.def	Temp =R16
.def	Temp1=R17
.def	Temp2=R18
.def	Temp3=R19
.def	Temp4=R20			;   /  SREG
.def	Temp5=R21 			;   / 
.def	Temp6=R22			; 		
.def	Temp7=R23			; 		
.def	Temp8=R24			;



;******************************************************************************
; 
;******************************************************************************


 .dseg	;  

curr_ch: .byte 1			;     (    0,1,2 )





;******************************************************************************
; 
;******************************************************************************


.equ	ADC_ADMUX = (1<<REFS0)|(0<<MUX0)			;     

.equ	ADC_ADCSRA= (1<<ADEN)|(1<<ADSC)|(1<<ADIF)|(7<<ADPS0)	;     (    )



;==============================================================================================================
;   // FLASH // 
;==============================================================================================================

.cseg	


;******************************************************************************
;  
;******************************************************************************	
	

.org 0					; External Pin, Power-on Reset, Brown-out Reset, and Watchdog Reset
rjmp reset				;  
				

; .org OC1Aaddr				; = 0x0016 Timer/Counter1 Compare Match A 
; rjmp OCR1A_COMP



; .org ADCCaddr				; ADC Conversion Complete 
; rjmp ADC_Conversion			; (    )




.org INT_VECTORS_SIZE			;   


;******************************************************************************
; 
;******************************************************************************

reset:					;  


;******************************************************************************
;   
;******************************************************************************


	cli				;    


;******************************************************************************
; , 
;******************************************************************************

	ldi Temp, low(RAMEND)		;  
	out SPL, Temp
	ldi Temp, high(RAMEND)
	out SPH, Temp




;******************************************************************************
;  
;******************************************************************************


;         
;     ,        
;        



;   "B"

	ldi Temp,0b00000010		;   "b" (0-, 1-)
	out DDRB,Temp			; 0000000 -  
					 
		
			

	ldi Temp,0b00000000		;  _0   "b" (   )  .
	out PortB,Temp			; 




;   "D"

	ldi Temp,0b01010000		;   "D" (0-, 1-)
	out DDRD,Temp			; 0000000 - 
					; 000x0000 -   					 
		
			

	ldi Temp,0b01000000		;     "D" /      
	out PortD,Temp			; 




;   ""

	ldi Temp,0b00000000		;   "" ( 0-, 1- )
	out DDR,Temp			; 00000 - 
					; 				 
		
			

				
;******************************************************************************
;   
;******************************************************************************


; _0 (  1024 )
; 8 
;    ( 3 : ,     )



					

	ldi Temp,(1<<COM0A1)|(1<<COM0A0)|(1<<WGM01)|(1<<WGM00)
	out TCCR0A, Temp	
				
					;    //   ,    (  )
					; 
					; 


					; COM0A1  /   OC1A // 
					; COM0A0  /   OC1A // 
					; COM0B1  /   OC1B // 
					; COM0B0  /   OC1B //  
					; WGM01=1 /  *
					; WGM00=1 /  *





	ldi Temp,(0<<WGM02)|(1<<cs02)|(1<<cs00)	
	out TCCR0B, Temp					


					;   = CK 1:1024 
					;   !!!


					; WGM02=0 /  * 
					; CS02=1  /  
					; CS01=0  /   
					; CS00=0  /   = CK 1:1024 (16/1024=15625) 1   = 0,000064 



					; 16000000:1024=15625 
					; 1:15625=0,000064 

					; 0,000064*256=0,016384 
					; 0,000064*1=0,000064 



	ldi Temp, 0x1E			;   0  255
	out OCR0A, Temp			;  30 ( 0x1E )  (    )
					;  255 ( 0xFF ) 











;******************************************************************************

; _1 (  1/64 )
; 16 
;        (  1  3  )





	LDI Temp, 0x00						;    
	sts OCR1AH, Temp					; 0,03  - 1875  ( 0x0753 ) 
	LDI Temp, 0x00						; 0.00  - 0  ( 0x0000 )  !					
	sts OCR1AL,Temp  					;  ------------------------------------  0,10 ,  6250  ( 0x186A )
								;  ------------------------------------  0,05 ,  3125  ( 0x0C35 )




	ldi Temp, (1<<COM1A1)|(0<<COM1A0)|(1<<wgm11)|(0<<wgm10)	;      ( fast pwm - top = icr )
	sts TCCR1A, Temp					; 

								; COM1A1 /   OC1A
								; COM1A0 /   OC1A 
								; COM1B1 /   OC1B 
								; COM1B0 /   OC1B
								; 
								; 
								; WGM11=1 /  
								; WGM10=0 /  


	ldi Temp, (1<<WGM13)|(1<<WGM12)|(1<<cs12)|(0<<cs10)	;  
	sts TCCR1B, Temp					;     = CK 1:256
								;   !!!

								; ICNC1=0 / 
								; ICES1=0 / 
								; WGM13=1 /  
								; WGM12=1 /  
								; CS12=0
								; CS11=1 /   = CK 1:256 (16/256=62500) 1   = 0,000016 
								; CS10=0 





	LDI Temp, 0xF4						;     
	sts ICR1H, Temp						;      
	LDI Temp, 0x24						; 1:1=1 // 1:0,000016=62500  -   ( 0xF424 )
	sts ICR1L, Temp						; 1:3=0,33 // 0,33:0,000016=20625  -   ( 0x5091 )
								; 
								; 
								; 
 								; ---------------------- 1:7=~0,14 // 0,14:0,000016=8750  ( 0x222E )
								; ---------------------- 1:10=0,1 // 0,1:0,000016=6250  ( 0x186A )
								



;	ldi Temp, (1<<OCIE1A)					;    
;	sts TIMSK1, Temp





	ldi Temp, 0						;   
	sts TCNT1H, Temp
	sts TCNT1L, Temp






;******************************************************************************
;   (     )
;******************************************************************************


	ldi Temp, 0			;    = 0
	STS curr_ch, Temp		;










;******************************************************************************
;  
;******************************************************************************

;   10  (  0  1023 ) ***************************************
;
;	ldi Temp,(1<<REFS0)|(0<<MUX0)		
;	sts ADMUX, Temp	
;					; REFS0=1 /   5V /
;					; ADLAR=0 /   10  ( 8     2    )
;					; MUX0=0  /    ADC0 (PA0)
;					; MUX1=0 
;					; MUX2=0 
;					; MUX3=0 		
;					; MUX4=0
;
;	
;
;	ldi Temp, (1<<ADEN)|(1<<ADSC)|(1<<ADATE)|(1<<ADIF)|(1<<ADIE)|(7<<ADPS0)
;	sts ADCSRA, Temp
;					; ADEN=1  /  
;					; ADSC=1  /   
;					; ADATE=1 /   
;					; ADIF=1  /      (   ,   )
;					; ADIE=1  /    
;					; ADPS2=1
;					; ADPS1=1
;					; ADPS0=1 /   1/128 ( 16  / 128 = 125  )
;
;
;
;;	ldi Temp, (0<<ADTS0)
;;	out ADCSRB,Temp
;
;
;					; ACME=0  /       //   .
;					; ADTS2=0
;					; ADTS1=0
;					; ADTS0=0 /    
;					; (       ) //   .
;
;
;
;
;
;					; *PUD=0 /   ,     //  
;					; *PSR10=0 /   _1 //  
;					; *PSR2=0 /   _2 //  
;
;
;
;
;
;
;
;

;******************************************************************************
;  
;******************************************************************************			

	RCALL	LCD_INIT		;   (  "LCD_INIT"     )


;******************************************************************************
;   
;******************************************************************************

;	sei				;   
	





;*******************************************************************************
;   *****************************************************************
;*******************************************************************************

main_cicle:



;    1-

																
	LDI R18, 0			;(Y) 1  (  0)	
	LDI R17, 0			;(X) 0   	
	RCALL LCD_POS			


;  ""

	LDI R16, 54			;   ''
	RCALL LCD_CHAR	

	LDI R16, 55			;   ''
	RCALL LCD_CHAR	
					
			
	LDI R16, 37			;   ''
	RCALL LCD_CHAR
						
			
	LDI R16, 53			;   ''
	RCALL LCD_CHAR	
			

	LDI R16, 55			;   ''
	RCALL LCD_CHAR			
		

	LDI R16, 78			;   '.'
	RCALL LCD_CHAR						
			


;  

	rcall Loop0			;  ( 2  )
	rcall Loop0






;*******************************************************************************************************************************
;  
;
;         ( 5  )

PRODUVKA:



;     

	ldi Temp, 0xFF			;    255 (   0  255 )
	out OCR0A, Temp			; 
					 


;   


	LDI Temp, 0x00			;    
	sts OCR1AH, Temp		; () --------------------------------------0,03  - 1875  ( 0x0753 ) 
	LDI Temp, 0x00			; () 0.00  - 0  ( 0x0000 )  !					
	sts OCR1AL,Temp  					




;  


	RCALL	LCD_INIT		;   (  "LCD_INIT"     )



;    1-

																
	LDI R18, 0			;(Y) 1  (  0)	
	LDI R17, 0			;(X) 0   	
	RCALL LCD_POS			


; 

	LDI R16, 52			;   ''
	RCALL LCD_CHAR	

	LDI R16, 53			;   ''
	RCALL LCD_CHAR	
					
			
	LDI R16, 51			;   ''
	RCALL LCD_CHAR
						
			
	LDI R16, 41			;   ''
	RCALL LCD_CHAR	
			

	LDI R16, 56			;   ''
	RCALL LCD_CHAR			
		

	LDI R16, 39			;   ''
	RCALL LCD_CHAR	
					

	LDI R16, 47			;   ''
	RCALL LCD_CHAR			
		

	LDI R16, 37			;   ''
	RCALL LCD_CHAR						


			

;  


	rcall Loop0			;  ( 5  )
	rcall Loop0
	rcall Loop0
	rcall Loop0
	rcall Loop0



;*******************************************************************************************************************************
; 
; 
;    
;     


ZAGIGANIE:



;  


	RCALL	LCD_INIT		;   (  "LCD_INIT"     )




;    1-

																
	LDI R18, 0			;(Y) 1  (  0)	
	LDI R17, 0			;(X) 0   	
	RCALL LCD_POS			



;   ""


	LDI R16, 44			;   ''
	RCALL LCD_CHAR	


	LDI R16, 37			;   ''
	RCALL LCD_CHAR	
					
			
	LDI R16, 43			;   ''
	RCALL LCD_CHAR
						
			
	LDI R16, 45			;   ''
	RCALL LCD_CHAR	
			

	LDI R16, 40			;   ''
	RCALL LCD_CHAR			
		

	LDI R16, 37			;   ''
	RCALL LCD_CHAR						
			

	LDI R16, 50			;   ''
	RCALL LCD_CHAR						


	LDI R16, 45			;   ''
	RCALL LCD_CHAR	
	

	LDI R16, 42			;   ''
	RCALL LCD_CHAR	
								




;     


	ldi Temp, 0x1E			;    30 (   0  255 )
	out OCR0A, Temp			; 
					 


	LDI Temp, 0x07			;    
	sts OCR1AH, Temp		; 0,03  - 1875  ( 0x0753 ) 
	LDI Temp, 0x53			;   !					
	sts OCR1AL,Temp  					



	LDI Temp, 0xF4			;      (   )
	sts ICR1H, Temp			; 
	LDI Temp, 0x24			; 1:1=1 // 1:0,000016=62500  -   ( 0xF424 )
	sts ICR1L, Temp			; 1:3=0,33 // 0,33:0,000016=20625  -   ( 0x5091 )
					
					 
					 


;   (    )

;   

	sbi PortD, 4			; D4 -    ( ON )
					

	rcall Loop0			;  ( 2  )
	rcall Loop0


	cbi PortD, 4			; D4 -    ( OFF )


	rcall Loop0			;  ( 1  )


;   

	sbi PortD, 4			; D4 -    ( ON )
					

	rcall Loop0			;  ( 2  )
	rcall Loop0


	cbi PortD, 4			; D4 -    ( OFF )


	rcall Loop0			;  ( 1  )


;   

	sbi PortD, 4			; D4 -    ( ON )
					

	rcall Loop0			;  ( 2  )
	rcall Loop0


	cbi PortD, 4			; D4 -    ( OFF )




;  


	ldi Temp, 0x64			;    100 (   0  255 )
	out OCR0A, Temp			; 
					 



;  


	rcall Loop0			;  ( 2  )
	rcall Loop0			; 
					;  ,          
					;       .










;*******************************************************************************************************************************
;  
; 
;    
;     
;    -    







;   10  (  0  1023 ) ***************************************

	ldi Temp,(1<<REFS0)|(0<<MUX0)		
	sts ADMUX, Temp	
						; REFS0=1 /   5V /
						; ADLAR=0 /   10  ( 8     2    )
						; MUX0=0  /    ADC0 (PA0)
						; MUX1=0 
						; MUX2=0 
						; MUX3=0 		
						; MUX4=0

	

	ldi Temp, (1<<ADEN)|(1<<ADSC)|(0<<ADATE)|(1<<ADIF)|(0<<ADIE)|(7<<ADPS0)
	sts ADCSRA, Temp
						; ADEN=1  /  
						; ADSC=1  /   
						; ADATE=0 /   
						; ADIF=1  /      (   ,   )
						; ADIE=0  /    
						; ADPS2=1 / 
						; ADPS1=1 / 
						; ADPS0=1 /   1/128 ( 16  / 128 = 125  )



;	ldi Temp, (0<<ADTS0)
;	out ADCSRB,Temp


						; ACME=0  /       //   .
						; ADTS2=0
						; ADTS1=0
						; ADTS0=0 /    
						; (       ) //   .





						; *PUD=0 /   ,     //  
						; *PSR10=0 /   _1 //  
						; *PSR2=0 /   _2 //  








;   


ADIF_check_cycle:				;    

	lds Temp, ADCSRA			;  ADCSRA
	sbrs Temp, ADIF				;   ,  ADIF . (ADIF=4)
	rjmp ADIF_check_cycle			;  ADIF  ,  



;  


	lds XL, ADCL				;        "X"
	lds XH, ADCH				; 
						;    0  1023




;      (        )


	ldi YL, 0x00				;   0
	ldi YH, 0x00				;      ,   


	rcall compare_XY16			; ...


	breq PEREGOREL_1			;     X=Y 
	brcs PEREGOREL_1			;     X<Y (      )
	rjmp ispraven				;     X>Y 


PEREGOREL_1:

	rjmp PEREGOREL				;    


ispraven:

	ldi YL, 0xDB				;   987 ( 0x03DB ) 
	ldi YH, 0x03				; 
						;       ,    
						;  




	rcall compare_XY16			; ...



	breq MAX_Regim				;     X=Y 
	brcs MAX_Regim				;     X<Y
	rjmp PRODUVKA1				;     X>Y 


PRODUVKA1:

	rjmp PRODUVKA				;    ,   



;*******************************************************************************************************************************
;  
; 

MAX_Regim:


;  


	RCALL	LCD_INIT		;   (  "LCD_INIT"     )




;    1-

																
	LDI R18, 0			;(Y) 1  (  0)	
	LDI R17, 0			;(X) 0   	
	RCALL LCD_POS			


;   " "



	LDI R16, 49			;   ''
	RCALL LCD_CHAR	

	LDI R16, 37			;   ''
	RCALL LCD_CHAR	
					
			
	LDI R16, 58			;   ''
	RCALL LCD_CHAR
						
			
	LDI R16, 16			;   ''
	RCALL LCD_CHAR	
			

	LDI R16, 53			;   ''
	RCALL LCD_CHAR			
		

	LDI R16, 42			;   ''
	RCALL LCD_CHAR						
			

	LDI R16, 43			;   ''
	RCALL LCD_CHAR						


	LDI R16, 45			;   ''
	RCALL LCD_CHAR	
	
		
	LDI R16, 49			;   ''
	RCALL LCD_CHAR	
			




;  


	ldi Temp, 0xFF			;    255 (   0  255 )
	out OCR0A, Temp			; 
					 




;    ( 2  )


	LDI Temp, 0x7A			;      (   )
	sts ICR1H, Temp			; 
	LDI Temp, 0x12			; 1:1=1 // 1:0,000016=62500  -   ( 0xF424 )
	sts ICR1L, Temp			; 1:3=0,33 // 0,33:0,000016=20625  -   ( 0x5091 )
					; 1:2=0,5 // 0,5:0,000016=31250  -   ( 0x7A12 )
					 



	rcall Loop0			;  ( 1  )


;*******************************************************************************************************************************
;  _1



;  


	RCALL	LCD_INIT		;   (  "LCD_INIT"     )


;    1-

																
	LDI R18, 0			;(Y) 1  (  0)	
	LDI R17, 0			;(X) 0   	
	RCALL LCD_POS			


; 


	LDI R16, 47			;   ''
	RCALL LCD_CHAR	

	LDI R16, 51			;   ''
	RCALL LCD_CHAR	
					
			
	LDI R16, 50			;   ''
	RCALL LCD_CHAR
						
			
	LDI R16, 55			;   ''
	RCALL LCD_CHAR	
			

	LDI R16, 53			;   ''
	RCALL LCD_CHAR			
		

	LDI R16, 51			;   ''
	RCALL LCD_CHAR						
			

	LDI R16, 48			;   ''
	RCALL LCD_CHAR						


	LDI R16, 65			;   ''
	RCALL LCD_CHAR						








;      

          
setting_ADS:

	LDI Temp, ADC_ADMUX			;   ADMUX (  )
	LDS Temp1, curr_ch			;     (    )

	OR Temp, Temp1      			;       (  "" )
	STS ADMUX, Temp				;   






;     
   
	LDI R16, ADC_ADCSRA
	STS ADCSRA, R16




;    



ADIF_check_cycle_1:				;    

	lds Temp, ADCSRA			;  ADCSRA
	sbrs Temp, ADIF				;   ,  ADIF . (ADIF=4)
	rjmp ADIF_check_cycle_1			;  ADIF  ,  




;    



	lds XL, ADCL				;      
	lds XH, ADCH				; 



;          



	LDS Temp, curr_ch			;    


	CPI Temp, 0				; _0 ?
	breq ADC_CH_00				;  ,    _0


	CPI Temp, 1				; _1 ?
	breq ADC_CH_10				;  ,    _1
	rjmp ADC_CH_2				;   _2



ADC_CH_00:

	rjmp ADC_CH_0				;  

ADC_CH_10:

	rjmp ADC_CH_1				;  



;****************

;    

ADC_CH_2:


;    4-

																
	LDI R18, 3			;(Y) 4  (  0)	
	LDI R17, 0			;(X) 0   	
	RCALL LCD_POS			


;  ( t   )


	LDI R16, 55			;   't'
	RCALL LCD_CHAR
	

	LDI R16, 82			;   ''
	RCALL LCD_CHAR	
					

	LDI R16, 51			;   ''
	RCALL LCD_CHAR		
		
	LDI R16, 43			;   ''
	RCALL LCD_CHAR

		
	LDI R16, 16			;   ''
	RCALL LCD_CHAR						
			


;     (XH:XL) - (   0  1023 )


;  16       HEX-
;    X (XH:XL)

	mov r16, XH
	rcall printhex
	mov r16, XL
	rcall printhex
 

;     


	ldi YH, 0x00			;   245 ( 70    ) ( 0x00F5 ) 
	ldi YL, 0xF5			; 
					


	rcall compare_XY16		; ...


	breq change_num_channel_0	;     X=Y 
	brcs change_num_channel_0	;     X<Y
	rjmp PEREGREV			;     X>Y 





; *********************

;     
ADC_CH_1:



;    3-

																
	LDI R18, 2			;(Y) 3-  (  0)	
	LDI R17, 0			;(X) 0   	
	RCALL LCD_POS			


;  (    )


	LDI R16, 55			;   't'
	RCALL LCD_CHAR
	

	LDI R16, 82			;   ''
	RCALL LCD_CHAR	
					
			
	LDI R16, 47			;   ''
	RCALL LCD_CHAR

		
	LDI R16, 54			;   ''
	RCALL LCD_CHAR	
			
		
	LDI R16, 16			;   ''
	RCALL LCD_CHAR						
			



;     (XH:XL) - (   0  1023 )


;  16       HEX-
;    X (XH:XL)

	mov r16, XH
	rcall printhex
	mov r16, XL
	rcall printhex
 

;     


	ldi YH, 0x00			;   245 ( 70    ) ( 0x00F5 ) 
	ldi YL, 0xF5			; 
					


	rcall compare_XY16		; ...


	breq change_num_channel_0	;     X=Y 
	brcs change_num_channel_0	;     X<Y
	rjmp PEREGREV			;     X>Y 


change_num_channel_0:

	rjmp change_num_channel		;  




;***************

;   



ADC_CH_0:


;      (         )


	ldi YL, 0x00			;   0
	ldi YH, 0x00			;      ,   
					; 
						

	rcall compare_XY16		; ...


	breq PEREGOREL_2		;     X=Y 
	brcs PEREGOREL_2		;     X<Y (      )
	rjmp ispraven_2			;     X>Y 


PEREGOREL_2:

	rjmp PEREGOREL			;    


ispraven_2:

;    2-
			
	LDI R18, 1			;(Y) 2  (  0)	
	LDI R17, 0			;(X) 0   	
	RCALL LCD_POS			



; 

	LDI R16, 52			;   ''
	RCALL LCD_CHAR	


	LDI R16, 48			;   ''
	RCALL LCD_CHAR	
					
			
	LDI R16, 37			;   ''
	RCALL LCD_CHAR
						
			
	LDI R16, 49			;   ''
	RCALL LCD_CHAR	
			

	LDI R16, 68			;   ''
	RCALL LCD_CHAR			
		

	LDI R16, 16			;   ''
	RCALL LCD_CHAR						
			


;   

;     (XH:XL)


	ldi YL, 0xd7			;   983 ( 0x03d7 ) 
	ldi YH, 0x03			; 
					;       ,    
					;  


	rcall compare_XY16		; ...


	breq gorit			;     X=Y 
	brcs gorit			;     X<Y
	rjmp potuhlo			;     X>Y 





gorit:


	LDI R16, 41			;   ''
	RCALL LCD_CHAR	
			

	LDI R16, 37			;   ''
	RCALL LCD_CHAR			
		

	LDI R16, 16			;   ''
	RCALL LCD_CHAR						
			

	rjmp change_num_channel




potuhlo:




	LDI R16, 50			;   ''
	RCALL LCD_CHAR	
			

	LDI R16, 42			;   ''
	RCALL LCD_CHAR			
		

	LDI R16, 55			;   ''
	RCALL LCD_CHAR						
			

;        
;   
;       



;  

	RCALL	LCD_INIT		;   (  "LCD_INIT"     )


;    1-

																
	LDI R18, 0			;(Y) 1  (  0)	
	LDI R17, 0			;(X) 0   	
	RCALL LCD_POS			


; 


	LDI R16, 52			;   ''
	RCALL LCD_CHAR	


	LDI R16, 51			;   ''
	RCALL LCD_CHAR	
					
			
	LDI R16, 55			;   ''
	RCALL LCD_CHAR
						
			
	LDI R16, 56			;   ''
	RCALL LCD_CHAR	
			

	LDI R16, 58			;   ''
	RCALL LCD_CHAR			
		



	rjmp STOP_nas_vent



;****************************************

change_num_channel:


;       


	LDS Temp, curr_ch			;    
            
	INC Temp				;    1

	CPI Temp, 3				;   3  ?
	brne SAVE_CURR_CH			;  ,    
	ldi Temp, 0				;  ,      !

SAVE_CURR_CH:

	STS curr_ch, Temp			;    







	rjmp setting_ADS			;     



;************************************************************************************

; 

PEREGREV:



;  

	RCALL	LCD_INIT		;   (  "LCD_INIT"     )




;    1-

																
	LDI R18, 0			;(Y) 1  (  0)	
	LDI R17, 0			;(X) 0   	
	RCALL LCD_POS			




; 


	LDI R16, 52			;   ''
	RCALL LCD_CHAR	


	LDI R16, 42			;   ''
	RCALL LCD_CHAR	
					
			
	LDI R16, 53			;   ''
	RCALL LCD_CHAR
						
			
	LDI R16, 42			;   ''
	RCALL LCD_CHAR	
			

	LDI R16, 40			;   ''
	RCALL LCD_CHAR			
		

	LDI R16, 53			;   ''
	RCALL LCD_CHAR						


	LDI R16, 42			;   ''
	RCALL LCD_CHAR			
		

	LDI R16, 39			;   ''
	RCALL LCD_CHAR						





	rjmp STOP_nas_vent



;************************************************************************************

;   

PEREGOREL:




;  

	RCALL	LCD_INIT		;   (  "LCD_INIT"     )




;    1-

																
	LDI R18, 0			;(Y) 1  (  0)	
	LDI R17, 0			;(X) 0   	
	RCALL LCD_POS			




; 


	LDI R16, 52			;   ''
	RCALL LCD_CHAR	


	LDI R16, 42			;   ''
	RCALL LCD_CHAR	
					
			
	LDI R16, 53			;   ''
	RCALL LCD_CHAR
						
			
	LDI R16, 42			;   ''
	RCALL LCD_CHAR	
			

	LDI R16, 40			;   ''
	RCALL LCD_CHAR			
	

	LDI R16, 51			;   ''
	RCALL LCD_CHAR						
	

	LDI R16, 53			;   ''
	RCALL LCD_CHAR						


	LDI R16, 42			;   ''
	RCALL LCD_CHAR			
		

	LDI R16, 48			;   ''
	RCALL LCD_CHAR						





	rjmp STOP_nas_vent



;*******************************************************************************

;     

STOP_nas_vent:


;   


	LDI Temp, 0x00			;    
	sts OCR1AH, Temp		; () --------------------------------------0,03  - 1875  ( 0x0753 ) 
	LDI Temp, 0x00			; () 0.00  - 0  ( 0x0000 )  !					
	sts OCR1AL,Temp  					


;       _1      _0







;      (  )

	ldi Temp, 0xFF			;    255 (   0  255 )
	out OCR0A, Temp			; 
					 


;  1 

	rcall Loop0



;  


	ldi Temp, 0x00			;    0 (   0  255 )
	out OCR0A, Temp			; 
					 


;   , -   ""


	ldi Temp, 0
	out TCCR0A, Temp

	ldi Temp, 0	
	out TCCR0B, Temp					




;     _1 (    ) ( invert )


	sbi PortD, 6			; D6 -  ( _1 )



			
;     



Ojidanie_CICLE:

	rjmp Ojidanie_CICLE






;*******************************************************************************************************************************
;   
;*******************************************************************************************************************************
;
;ADC_Conversion:
;
;
;
;
;	in temp4,SREG				;  "SREG"/////////////////////////////////////////////////////
;	push temp4
;
;
;
;    ***********************************************************************
;
;
;
;	lds XL, ADCL				;     
;	lds XH, ADCH				; 
;						;    0  1023
;
;
;
;
;***************************************************************************************************
;    *******************************************************************************
;
;
;OCR1A_COMP_EXIT:				; 
;  
;	pop temp4				;  "SREG" ////////////////////////////////////////////////////
;	out SREG, temp4
;
;
;
;	RETI					;   
;
;
;
;
;**************************************************************************************************************************
;***************************************************************************************************************************
;****************************************************************************************************************************
;
; 



;*******************************************************************************
;   (  1  )
;*******************************************************************************



Loop0:

	ldi Temp1,0
	ldi Temp2,0
	ldi Temp3,0


Loop:     

	dec Temp1
	brne Loop

	dec Temp2
	brne Loop

	dec Temp3
	brne Loop


ret






;*******************************************************************************
;     hex ,   . 
;*******************************************************************************

  
;  r16    

printhex: 
   
	push r16		;      (    )
	swap r16		;   ,      
	rcall printhex1		;       
	pop r16			;    


printhex1: 
   
	andi r16, 0x0f		;    ( )
	rcall lcd_char		;      
	ret    





;******************************************************************
;  16-  
;******************************************************************



compare_XY16:

	cp XH, YH			;    
	breq xh_eq_yh			;    ,    xl  yl
					;   -   X<Y
					;   -   X>Y
	ret



xh_eq_yh:

	cp XL, YL			;    
					;  Z=1  X=Y
					;   -   X<Y
					;   -   X>Y




	ret   



;*************************************************************    

















;*******************************************************************************
;  
;*******************************************************************************

.include "lcd5110rus.asm"		;   	


; .include "HEX_to_BCD"			;   HEX_to_BCD


